/* Generated by wayland-scanner 1.19.0 */

#ifndef E_GADGET_SERVER_PROTOCOL_H
#define E_GADGET_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_e_gadget The e_gadget protocol
 * @section page_ifaces_e_gadget Interfaces
 * - @subpage page_iface_e_gadget - 
 */
struct e_gadget;
struct wl_surface;

#ifndef E_GADGET_INTERFACE
#define E_GADGET_INTERFACE
/**
 * @page page_iface_e_gadget e_gadget
 * @section page_iface_e_gadget_api API
 * See @ref iface_e_gadget.
 */
/**
 * @defgroup iface_e_gadget The e_gadget interface
 */
extern const struct wl_interface e_gadget_interface;
#endif

#ifndef E_GADGET_ORIENT_ENUM
#define E_GADGET_ORIENT_ENUM
enum e_gadget_orient {
	E_GADGET_ORIENT_NONE = 0,
	E_GADGET_ORIENT_HORIZONTAL = 1,
	E_GADGET_ORIENT_VERTICAL = 2,
};
#endif /* E_GADGET_ORIENT_ENUM */

#ifndef E_GADGET_GRAVITY_ENUM
#define E_GADGET_GRAVITY_ENUM
enum e_gadget_gravity {
	E_GADGET_GRAVITY_NONE = 0,
	E_GADGET_GRAVITY_LEFT = 1,
	E_GADGET_GRAVITY_RIGHT = 2,
	E_GADGET_GRAVITY_TOP = 3,
	E_GADGET_GRAVITY_BOTTOM = 4,
	E_GADGET_GRAVITY_CENTER = 5,
};
#endif /* E_GADGET_GRAVITY_ENUM */

#ifndef E_GADGET_ANCHOR_ENUM
#define E_GADGET_ANCHOR_ENUM
enum e_gadget_anchor {
	E_GADGET_ANCHOR_NONE = 0,
	E_GADGET_ANCHOR_LEFT = 1,
	E_GADGET_ANCHOR_RIGHT = 2,
	E_GADGET_ANCHOR_TOP = 4,
	E_GADGET_ANCHOR_BOTTOM = 8,
};
#endif /* E_GADGET_ANCHOR_ENUM */

/**
 * @ingroup iface_e_gadget
 * @struct e_gadget_interface
 */
struct e_gadget_interface {
	/**
	 */
	void (*open_uri)(struct wl_client *client,
			 struct wl_resource *resource,
			 const char *uri);
	/**
	 */
	void (*set_tooltip)(struct wl_client *client,
			    struct wl_resource *resource,
			    struct wl_resource *surface);
};

#define E_GADGET_GADGET_ANCHOR 0
#define E_GADGET_GADGET_ORIENT 1
#define E_GADGET_GADGET_GRAVITY 2
#define E_GADGET_GADGET_CONFIGURE 3

/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_GADGET_ANCHOR_SINCE_VERSION 1
/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_GADGET_ORIENT_SINCE_VERSION 1
/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_GADGET_GRAVITY_SINCE_VERSION 1
/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_GADGET_CONFIGURE_SINCE_VERSION 1

/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_OPEN_URI_SINCE_VERSION 1
/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_SET_TOOLTIP_SINCE_VERSION 1

/**
 * @ingroup iface_e_gadget
 * Sends an gadget_anchor event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
e_gadget_send_gadget_anchor(struct wl_resource *resource_, uint32_t anchor)
{
	wl_resource_post_event(resource_, E_GADGET_GADGET_ANCHOR, anchor);
}

/**
 * @ingroup iface_e_gadget
 * Sends an gadget_orient event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
e_gadget_send_gadget_orient(struct wl_resource *resource_, uint32_t orient)
{
	wl_resource_post_event(resource_, E_GADGET_GADGET_ORIENT, orient);
}

/**
 * @ingroup iface_e_gadget
 * Sends an gadget_gravity event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
e_gadget_send_gadget_gravity(struct wl_resource *resource_, uint32_t gravity)
{
	wl_resource_post_event(resource_, E_GADGET_GADGET_GRAVITY, gravity);
}

/**
 * @ingroup iface_e_gadget
 * Sends an gadget_configure event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
e_gadget_send_gadget_configure(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, E_GADGET_GADGET_CONFIGURE);
}

#ifdef  __cplusplus
}
#endif

#endif
