/* Generated by wayland-scanner 1.19.0 */

#ifndef ZWP_ACTION_ROUTE_CLIENT_PROTOCOL_H
#define ZWP_ACTION_ROUTE_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_zwp_action_route The zwp_action_route protocol
 * @section page_ifaces_zwp_action_route Interfaces
 * - @subpage page_iface_action_route - 
 * - @subpage page_iface_action_route_bind - 
 * - @subpage page_iface_action_route_key_grab - 
 */
struct action_route;
struct action_route_bind;
struct action_route_key_grab;
struct wl_surface;

#ifndef ACTION_ROUTE_INTERFACE
#define ACTION_ROUTE_INTERFACE
/**
 * @page page_iface_action_route action_route
 * @section page_iface_action_route_api API
 * See @ref iface_action_route.
 */
/**
 * @defgroup iface_action_route The action_route interface
 */
extern const struct wl_interface action_route_interface;
#endif
#ifndef ACTION_ROUTE_BIND_INTERFACE
#define ACTION_ROUTE_BIND_INTERFACE
/**
 * @page page_iface_action_route_bind action_route_bind
 * @section page_iface_action_route_bind_api API
 * See @ref iface_action_route_bind.
 */
/**
 * @defgroup iface_action_route_bind The action_route_bind interface
 */
extern const struct wl_interface action_route_bind_interface;
#endif
#ifndef ACTION_ROUTE_KEY_GRAB_INTERFACE
#define ACTION_ROUTE_KEY_GRAB_INTERFACE
/**
 * @page page_iface_action_route_key_grab action_route_key_grab
 * @section page_iface_action_route_key_grab_api API
 * See @ref iface_action_route_key_grab.
 */
/**
 * @defgroup iface_action_route_key_grab The action_route_key_grab interface
 */
extern const struct wl_interface action_route_key_grab_interface;
#endif

#ifndef ACTION_ROUTE_MODE_ENUM
#define ACTION_ROUTE_MODE_ENUM
/**
 * @ingroup iface_action_route
 * Allows activation for exactly one client at all times
 */
enum action_route_mode {
	/**
	 * Activatable by any surface if its wl_client has focus
	 */
	ACTION_ROUTE_MODE_FOCUS_SHARED = 1,
	/**
	 * Activatable by topmost surface with focus
	 */
	ACTION_ROUTE_MODE_FOCUS_TOPMOST = 2,
	/**
	 * Activatable by one surface at any time
	 */
	ACTION_ROUTE_MODE_EXCLUSIVE = 3,
};
#endif /* ACTION_ROUTE_MODE_ENUM */

#ifndef ACTION_ROUTE_MODIFIERS_ENUM
#define ACTION_ROUTE_MODIFIERS_ENUM
enum action_route_modifiers {
	ACTION_ROUTE_MODIFIERS_SHIFT = 1,
	ACTION_ROUTE_MODIFIERS_CONTROL = 2,
	ACTION_ROUTE_MODIFIERS_ALT = 4,
	ACTION_ROUTE_MODIFIERS_WIN = 8,
	ACTION_ROUTE_MODIFIERS_ALTGR = 16,
};
#endif /* ACTION_ROUTE_MODIFIERS_ENUM */

#define ACTION_ROUTE_BIND_ACTION 0
#define ACTION_ROUTE_GRAB_KEY 1


/**
 * @ingroup iface_action_route
 */
#define ACTION_ROUTE_BIND_ACTION_SINCE_VERSION 1
/**
 * @ingroup iface_action_route
 */
#define ACTION_ROUTE_GRAB_KEY_SINCE_VERSION 1

/** @ingroup iface_action_route */
static inline void
action_route_set_user_data(struct action_route *action_route, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) action_route, user_data);
}

/** @ingroup iface_action_route */
static inline void *
action_route_get_user_data(struct action_route *action_route)
{
	return wl_proxy_get_user_data((struct wl_proxy *) action_route);
}

static inline uint32_t
action_route_get_version(struct action_route *action_route)
{
	return wl_proxy_get_version((struct wl_proxy *) action_route);
}

/** @ingroup iface_action_route */
static inline void
action_route_destroy(struct action_route *action_route)
{
	wl_proxy_destroy((struct wl_proxy *) action_route);
}

/**
 * @ingroup iface_action_route
 *
 */
static inline struct action_route_bind *
action_route_bind_action(struct action_route *action_route, const char *action)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_constructor((struct wl_proxy *) action_route,
			 ACTION_ROUTE_BIND_ACTION, &action_route_bind_interface, NULL, action);

	return (struct action_route_bind *) id;
}

/**
 * @ingroup iface_action_route
 *
 */
static inline struct action_route_key_grab *
action_route_grab_key(struct action_route *action_route, struct wl_surface *surface, const char *key, uint32_t mode, uint32_t modifiers, const char *action, const char *params)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_constructor((struct wl_proxy *) action_route,
			 ACTION_ROUTE_GRAB_KEY, &action_route_key_grab_interface, NULL, surface, key, mode, modifiers, action, params);

	return (struct action_route_key_grab *) id;
}

#ifndef ACTION_ROUTE_BIND_STATE_ENUM
#define ACTION_ROUTE_BIND_STATE_ENUM
enum action_route_bind_state {
	ACTION_ROUTE_BIND_STATE_REJECTED = 0,
	ACTION_ROUTE_BIND_STATE_ACTIVE = 1,
	ACTION_ROUTE_BIND_STATE_QUEUED = 2,
};
#endif /* ACTION_ROUTE_BIND_STATE_ENUM */

/**
 * @ingroup iface_action_route_bind
 * @struct action_route_bind_listener
 */
struct action_route_bind_listener {
	/**
	 * Status update on a bind request
	 *
	 * 
	 */
	void (*status)(void *data,
		       struct action_route_bind *action_route_bind,
		       uint32_t state);
	/**
	 * The bind has completed execution
	 *
	 * 
	 */
	void (*end)(void *data,
		    struct action_route_bind *action_route_bind);
};

/**
 * @ingroup iface_action_route_bind
 */
static inline int
action_route_bind_add_listener(struct action_route_bind *action_route_bind,
			       const struct action_route_bind_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) action_route_bind,
				     (void (**)(void)) listener, data);
}

#define ACTION_ROUTE_BIND_ACTIVATE 0
#define ACTION_ROUTE_BIND_DESTROY 1

/**
 * @ingroup iface_action_route_bind
 */
#define ACTION_ROUTE_BIND_STATUS_SINCE_VERSION 1
/**
 * @ingroup iface_action_route_bind
 */
#define ACTION_ROUTE_BIND_END_SINCE_VERSION 1

/**
 * @ingroup iface_action_route_bind
 */
#define ACTION_ROUTE_BIND_ACTIVATE_SINCE_VERSION 1
/**
 * @ingroup iface_action_route_bind
 */
#define ACTION_ROUTE_BIND_DESTROY_SINCE_VERSION 1

/** @ingroup iface_action_route_bind */
static inline void
action_route_bind_set_user_data(struct action_route_bind *action_route_bind, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) action_route_bind, user_data);
}

/** @ingroup iface_action_route_bind */
static inline void *
action_route_bind_get_user_data(struct action_route_bind *action_route_bind)
{
	return wl_proxy_get_user_data((struct wl_proxy *) action_route_bind);
}

static inline uint32_t
action_route_bind_get_version(struct action_route_bind *action_route_bind)
{
	return wl_proxy_get_version((struct wl_proxy *) action_route_bind);
}

/**
 * @ingroup iface_action_route_bind
 */
static inline void
action_route_bind_activate(struct action_route_bind *action_route_bind, const char *params)
{
	wl_proxy_marshal((struct wl_proxy *) action_route_bind,
			 ACTION_ROUTE_BIND_ACTIVATE, params);
}

/**
 * @ingroup iface_action_route_bind
 *
 */
static inline void
action_route_bind_destroy(struct action_route_bind *action_route_bind)
{
	wl_proxy_marshal((struct wl_proxy *) action_route_bind,
			 ACTION_ROUTE_BIND_DESTROY);

	wl_proxy_destroy((struct wl_proxy *) action_route_bind);
}

#ifndef ACTION_ROUTE_KEY_GRAB_STATE_ENUM
#define ACTION_ROUTE_KEY_GRAB_STATE_ENUM
enum action_route_key_grab_state {
	ACTION_ROUTE_KEY_GRAB_STATE_REJECTED = 0,
	ACTION_ROUTE_KEY_GRAB_STATE_ACTIVE = 1,
	ACTION_ROUTE_KEY_GRAB_STATE_QUEUED = 2,
};
#endif /* ACTION_ROUTE_KEY_GRAB_STATE_ENUM */

/**
 * @ingroup iface_action_route_key_grab
 * @struct action_route_key_grab_listener
 */
struct action_route_key_grab_listener {
	/**
	 * Status update on a grab request
	 *
	 * 
	 */
	void (*status)(void *data,
		       struct action_route_key_grab *action_route_key_grab,
		       uint32_t state);
};

/**
 * @ingroup iface_action_route_key_grab
 */
static inline int
action_route_key_grab_add_listener(struct action_route_key_grab *action_route_key_grab,
				   const struct action_route_key_grab_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) action_route_key_grab,
				     (void (**)(void)) listener, data);
}

#define ACTION_ROUTE_KEY_GRAB_DESTROY 0

/**
 * @ingroup iface_action_route_key_grab
 */
#define ACTION_ROUTE_KEY_GRAB_STATUS_SINCE_VERSION 1

/**
 * @ingroup iface_action_route_key_grab
 */
#define ACTION_ROUTE_KEY_GRAB_DESTROY_SINCE_VERSION 1

/** @ingroup iface_action_route_key_grab */
static inline void
action_route_key_grab_set_user_data(struct action_route_key_grab *action_route_key_grab, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) action_route_key_grab, user_data);
}

/** @ingroup iface_action_route_key_grab */
static inline void *
action_route_key_grab_get_user_data(struct action_route_key_grab *action_route_key_grab)
{
	return wl_proxy_get_user_data((struct wl_proxy *) action_route_key_grab);
}

static inline uint32_t
action_route_key_grab_get_version(struct action_route_key_grab *action_route_key_grab)
{
	return wl_proxy_get_version((struct wl_proxy *) action_route_key_grab);
}

/**
 * @ingroup iface_action_route_key_grab
 *
 */
static inline void
action_route_key_grab_destroy(struct action_route_key_grab *action_route_key_grab)
{
	wl_proxy_marshal((struct wl_proxy *) action_route_key_grab,
			 ACTION_ROUTE_KEY_GRAB_DESTROY);

	wl_proxy_destroy((struct wl_proxy *) action_route_key_grab);
}

#ifdef  __cplusplus
}
#endif

#endif
