/* Generated by wayland-scanner 1.19.0 */

#ifndef E_GADGET_CLIENT_PROTOCOL_H
#define E_GADGET_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_e_gadget The e_gadget protocol
 * @section page_ifaces_e_gadget Interfaces
 * - @subpage page_iface_e_gadget - 
 */
struct e_gadget;
struct wl_surface;

#ifndef E_GADGET_INTERFACE
#define E_GADGET_INTERFACE
/**
 * @page page_iface_e_gadget e_gadget
 * @section page_iface_e_gadget_api API
 * See @ref iface_e_gadget.
 */
/**
 * @defgroup iface_e_gadget The e_gadget interface
 */
extern const struct wl_interface e_gadget_interface;
#endif

#ifndef E_GADGET_ORIENT_ENUM
#define E_GADGET_ORIENT_ENUM
enum e_gadget_orient {
	E_GADGET_ORIENT_NONE = 0,
	E_GADGET_ORIENT_HORIZONTAL = 1,
	E_GADGET_ORIENT_VERTICAL = 2,
};
#endif /* E_GADGET_ORIENT_ENUM */

#ifndef E_GADGET_GRAVITY_ENUM
#define E_GADGET_GRAVITY_ENUM
enum e_gadget_gravity {
	E_GADGET_GRAVITY_NONE = 0,
	E_GADGET_GRAVITY_LEFT = 1,
	E_GADGET_GRAVITY_RIGHT = 2,
	E_GADGET_GRAVITY_TOP = 3,
	E_GADGET_GRAVITY_BOTTOM = 4,
	E_GADGET_GRAVITY_CENTER = 5,
};
#endif /* E_GADGET_GRAVITY_ENUM */

#ifndef E_GADGET_ANCHOR_ENUM
#define E_GADGET_ANCHOR_ENUM
enum e_gadget_anchor {
	E_GADGET_ANCHOR_NONE = 0,
	E_GADGET_ANCHOR_LEFT = 1,
	E_GADGET_ANCHOR_RIGHT = 2,
	E_GADGET_ANCHOR_TOP = 4,
	E_GADGET_ANCHOR_BOTTOM = 8,
};
#endif /* E_GADGET_ANCHOR_ENUM */

/**
 * @ingroup iface_e_gadget
 * @struct e_gadget_listener
 */
struct e_gadget_listener {
	/**
	 */
	void (*gadget_anchor)(void *data,
			      struct e_gadget *e_gadget,
			      uint32_t anchor);
	/**
	 */
	void (*gadget_orient)(void *data,
			      struct e_gadget *e_gadget,
			      uint32_t orient);
	/**
	 */
	void (*gadget_gravity)(void *data,
			       struct e_gadget *e_gadget,
			       uint32_t gravity);
	/**
	 */
	void (*gadget_configure)(void *data,
				 struct e_gadget *e_gadget);
};

/**
 * @ingroup iface_e_gadget
 */
static inline int
e_gadget_add_listener(struct e_gadget *e_gadget,
		      const struct e_gadget_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) e_gadget,
				     (void (**)(void)) listener, data);
}

#define E_GADGET_OPEN_URI 0
#define E_GADGET_SET_TOOLTIP 1

/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_GADGET_ANCHOR_SINCE_VERSION 1
/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_GADGET_ORIENT_SINCE_VERSION 1
/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_GADGET_GRAVITY_SINCE_VERSION 1
/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_GADGET_CONFIGURE_SINCE_VERSION 1

/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_OPEN_URI_SINCE_VERSION 1
/**
 * @ingroup iface_e_gadget
 */
#define E_GADGET_SET_TOOLTIP_SINCE_VERSION 1

/** @ingroup iface_e_gadget */
static inline void
e_gadget_set_user_data(struct e_gadget *e_gadget, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) e_gadget, user_data);
}

/** @ingroup iface_e_gadget */
static inline void *
e_gadget_get_user_data(struct e_gadget *e_gadget)
{
	return wl_proxy_get_user_data((struct wl_proxy *) e_gadget);
}

static inline uint32_t
e_gadget_get_version(struct e_gadget *e_gadget)
{
	return wl_proxy_get_version((struct wl_proxy *) e_gadget);
}

/** @ingroup iface_e_gadget */
static inline void
e_gadget_destroy(struct e_gadget *e_gadget)
{
	wl_proxy_destroy((struct wl_proxy *) e_gadget);
}

/**
 * @ingroup iface_e_gadget
 */
static inline void
e_gadget_open_uri(struct e_gadget *e_gadget, const char *uri)
{
	wl_proxy_marshal((struct wl_proxy *) e_gadget,
			 E_GADGET_OPEN_URI, uri);
}

/**
 * @ingroup iface_e_gadget
 */
static inline void
e_gadget_set_tooltip(struct e_gadget *e_gadget, struct wl_surface *surface)
{
	wl_proxy_marshal((struct wl_proxy *) e_gadget,
			 E_GADGET_SET_TOOLTIP, surface);
}

#ifdef  __cplusplus
}
#endif

#endif
